package com.mdd.admin.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.mdd.admin.service.IDecorateTabbarService;
import com.mdd.admin.validate.decorate.DecorateTabsValidate;
import com.mdd.admin.vo.decorate.DecorateTabbarVo;
import com.mdd.admin.vo.decorate.DecorateTabsListsVo;
import com.mdd.common.entity.decorate.DecorateTabbar;
import com.mdd.common.mapper.decorate.DecorateTabbarMapper;
import com.mdd.common.util.ConfigUtils;
import com.mdd.common.util.MapUtils;
import com.mdd.common.util.StringUtils;
import com.mdd.common.util.TimeUtils;
import com.mdd.common.util.UrlUtils;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class DecorateTabbarServiceImpl implements IDecorateTabbarService {
   @Resource
   DecorateTabbarMapper decorateTabbarMapper;

   public DecorateTabbarVo detail() {
      List<DecorateTabbar> list = this.decorateTabbarMapper.selectList((Wrapper)(new QueryWrapper()).orderByAsc("id"));
      List<DecorateTabsListsVo> tabList = new LinkedList();
      Iterator var3 = list.iterator();

      while(var3.hasNext()) {
         DecorateTabbar tab = (DecorateTabbar)var3.next();
         DecorateTabsListsVo vo = new DecorateTabsListsVo();
         vo.setId(tab.getId());
         vo.setName(tab.getName());
         vo.setSelected(UrlUtils.toAbsoluteUrl(tab.getSelected()));
         vo.setUnselected(UrlUtils.toAbsoluteUrl(tab.getUnselected()));
         vo.setLink(JSON.parse(tab.getLink()));
         vo.setCreateTime(TimeUtils.timestampToDate(tab.getCreateTime()));
         vo.setUpdateTime(TimeUtils.timestampToDate(tab.getUpdateTime()));
         tabList.add(vo);
      }

      String tabbar = ConfigUtils.get("tabbar", "style", "{}");
      DecorateTabbarVo response = new DecorateTabbarVo();
      response.setStyle(MapUtils.jsonToMap(tabbar));
      response.setList(tabList);
      return response;
   }

   @Transactional
   public void save(DecorateTabsValidate tabsValidate) {
      this.decorateTabbarMapper.delete((Wrapper)(new QueryWrapper()).gt("id", 0));
      Iterator var2 = tabsValidate.getList().iterator();

      while(var2.hasNext()) {
         DecorateTabsListsVo obj = (DecorateTabsListsVo)var2.next();
         DecorateTabbar model = new DecorateTabbar();
         model.setName(obj.getName());
         model.setLink(JSON.toJSONString(obj.getLink()));
         model.setSelected(UrlUtils.toRelativeUrl(obj.getSelected()));
         model.setUnselected(UrlUtils.toRelativeUrl(obj.getUnselected()));
         model.setCreateTime(System.currentTimeMillis() / 1000L);
         model.setUpdateTime(System.currentTimeMillis() / 1000L);
         this.decorateTabbarMapper.insert(model);
      }

      if (StringUtils.isNotNull(tabsValidate.getStyle())) {
         ConfigUtils.set("tabbar", "style", JSON.toJSONString(tabsValidate.getStyle()));
      }

   }
}
